/*----- PROTECTED REGION ID(MyDevice.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        MyDevice.cpp
//
// description : C++ source for the MyDevice class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               MyDevice are implemented in this file.
//
// project :     MyDevice
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <MyDevice.h>
#include <MyDeviceClass.h>

/*----- PROTECTED REGION END -----*/	//	MyDevice.cpp

/**
 *  MyDevice class description:
 *    Test my device
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed is:
//================================================================
//  Text  |  Tango::DevString	Scalar
//================================================================

namespace MyDevice_ns
{
/*----- PROTECTED REGION ID(MyDevice::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	MyDevice::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : MyDevice::MyDevice()
 *	Description : Constructors for a Tango device
 *                implementing the classMyDevice
 */
//--------------------------------------------------------
MyDevice::MyDevice(Tango::DeviceClass *cl, string &s)
 : Tango::Device_4Impl(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(MyDevice::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::constructor_1
}
//--------------------------------------------------------
MyDevice::MyDevice(Tango::DeviceClass *cl, const char *s)
 : Tango::Device_4Impl(cl, s)
{
	/*----- PROTECTED REGION ID(MyDevice::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::constructor_2
}
//--------------------------------------------------------
MyDevice::MyDevice(Tango::DeviceClass *cl, const char *s, const char *d)
 : Tango::Device_4Impl(cl, s, d)
{
	/*----- PROTECTED REGION ID(MyDevice::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : MyDevice::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void MyDevice::delete_device()
{
	DEBUG_STREAM << "MyDevice::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(MyDevice::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::delete_device
	delete[] attr_Text_read;
}

//--------------------------------------------------------
/**
 *	Method      : MyDevice::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void MyDevice::init_device()
{
	DEBUG_STREAM << "MyDevice::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(MyDevice::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::init_device_before
	
	//	No device property to be read from database
	
	attr_Text_read = new Tango::DevString[1];

	/*----- PROTECTED REGION ID(MyDevice::init_device) ENABLED START -----*/
	
	//	Initialize device
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::init_device
}


//--------------------------------------------------------
/**
 *	Method      : MyDevice::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void MyDevice::always_executed_hook()
{
	INFO_STREAM << "MyDevice::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(MyDevice::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : MyDevice::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void MyDevice::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "MyDevice::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(MyDevice::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Text related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void MyDevice::read_Text(Tango::Attribute &attr)
{
	DEBUG_STREAM << "MyDevice::read_Text(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(MyDevice::read_Text) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_Text_read);
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::read_Text
}
//--------------------------------------------------------
/**
 *	Write attribute Text related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void MyDevice::write_Text(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "MyDevice::write_Text(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevString	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(MyDevice::write_Text) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::write_Text
}

//--------------------------------------------------------
/**
 *	Method      : MyDevice::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void MyDevice::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(MyDevice::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	MyDevice::add_dynamic_attributes
}


/*----- PROTECTED REGION ID(MyDevice::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	MyDevice::namespace_ending
} //	namespace
